<?php

	#uDOC:CHANGELOG 2.333 CHANGELOG Cambiado a no-pconnect porque ya estaba medio locozon el uObject
	
	class uObject {
		
		/** Oooh padre Saturniano de todos los objetos, danos la paz.... */
		
		var $Error_History			= Array();
		var $Warning_History		= Array();
		var $Error					= null;
		var $Warning				= null;
		var $DEBUG					= null;
		var $SQLLink				= null;
		var $Debugger2Log			= null;
		protected $_uoSQLData		= null;
		
		function setError($newerr) {
			#uDOC:TITLE setError
			#uDOC:DESCR Fija un error en el objeto
			#uDOC:RTVAL bool false siempre 
			
			$this->Error_History[] = $newerr;
			$this->Error = $newerr;
			$this->debuggerShow($newerr, 1, "error");
			return false;
		}
		
		function setWarning($warn) {
			#uDOC:TITLE setWarning
			#uDOC:DESCR Fija un warning en el uobject que puede ser sacado despues
			#uDOC:RTVAL bool false siempre
			
			$this->Warning_History[] = $warn;
			$this->Warning = $warn;
			$this->debuggerShow($warn, 1, "warn");
		}
		
		function Error() {
			#uDOC:TITLE Error 
			#uDOC:DESCR Regresa el ultimo error registrado en el uobject
			#uDOC:RTVAL	string Texto de ultimo error que paso, si no hya error ultimo null
			
			return $this->Error;
		}
		
		function Debugger2Log($pon = null) {
			if($pon !== null) {
				$this->Debugger2Log = $pon;
			}
			return $this->Debugger2Log;
		}
		
		function DEBUG($prio = null) {
			#uDOC:TITLE DEBUG
			#uDOC:DESCR Lee o fija el nivel de debug de un objeto
			#uDOC:RTVAL int Nivel de debug actual (generalmente de 1 a 5)
			
			// Si recibimos un nivel de debug, ponlo:
			if($prio !== null) { $this->DEBUG = $prio; }
			
			// Si hay un constante UOBJECT_DEBUG, entonces regresa eso como debug.
			// De esta forma podemos definir un nivel de debug antes de inicializar 
			// un objeto (para que jale en el constructor):
			
			if(defined('UOBJECT_DEBUG')) {
				return UOBJECT_DEBUG;
			} else {
				return $this->DEBUG;
			}
		}
		
		function debuggerShow($message, $level = 1, $class = "" ) {
			#uDOC:TITLE debuggerShow
			#uDOC:DESCR Saca un mensaje de debug segun el nivel requerido
			#uDOC:RTVAL bool Siempre true
			
			if($this->DEBUG() >= $level) {

				// La clase de mensaje default es info:
				if(! $class) { $class = "info"; }
				
				// Si hay $this, logueamos tambien la clase: 
				if($this) {
					if(($this->Debugger2Log()) || (! isset($_SERVER['SERVER_SOFTWARE']))) {
						$classname = get_class($this) . ": ";
					} else {
						$classname = "<span style=\"color: #666;\">".get_class($this).":</span> ";						
					}
				}
				
				# Haz el dump del recado al log o al browser, a segun:
				if($this->Debugger2Log()) {
					error_log('[' . strtoupper($class) . '] ' . $classname . $message);
				} elseif(isset($_SERVER['SERVER_SOFTWARE'])) {
					// Errores al browser:
					if($class == "info") {
						$tag = "<span style=\"color:blue;font-weight:bold;\">[INFO]</span> $classname";
					} elseif($class == "warn") {
						$tag = "<span style=\"color:#fc0;font-weight:bold;\">[WARN]</span> $classname";
					} elseif($class == "error") {
						$tag = "<span style=\"color:#c33;font-weight:bold;\">[ERROR] $classname";
					}
					
					print "<div style=\"font-size: 11px;font-family: monospace;\">$tag$message</div>";
				
				// Si no hay variable SERVER_SOFTWARE es que a la mejor estamos en la consola y 
				// hay que comportarse mas como script:
				
				} else {
					// Errores al browser:
					if($class == "info") {
						$tag = "[INFO] $classname";
					} elseif($class == "warn") {
						$tag = "[WARN] $classname";
					} elseif($class == "error") {
						$tag = "[ERROR] $classname";
					}
					
					print "$tag$message\n";
				}
			}
			
		}
		
		function uobject_setSQLInfo($username, $password, $hostname = null, $database = null) {
			#uDOC:TITLE uobject_setSQLInfo
			#uDOC:DESCR Fija los datos que necesita el uobject para conectar al SQL 
			
			// Host default es localhost
			if($hostname === null) { $hostname = "localhost"; }
			
			$this->_uoSQLData = Array(
				"username"	=> $username,
				"password"	=> $password,
				"hostname"	=> $hostname,
				"database"	=> $database,
				"tried"		=> false,
			);
		}
		function _uoSQLLink() {
			return $this->SQLLink();
		}
		
		function SQLLink() {
			#uDOC:TITLE SQLLink
			#uDOC:DESCR Regresa la conexion de SQL del uboject
			#uDOC:TEXT Para mas info de esta caracteristica ver aqui: http://www.ulabs.uservers.net/proyectos/uObject/doc/object_sqlcnx.php 
			
			// So ya hay link, regresa aqui:
			if(is_resource($this->SQLLink))	{ return $this->SQLLink; }
			
			// Si no hay datos, pues false: 
			if(! is_array($this->_uoSQLData))	{ return $this->setError("Imposible conectar a SQL sin datos"); }
			
			// Si ya probamos los datos que tenemos, regresa false:
			// if($this->_uoSQLData['tried'])		{ return false; }
			
			if(! $this->_uoSQLData['hostname']) { $this->_uoSQLData['hostname'] = "localhost"; }
			
			$this->SQLLink = @mysql_connect($this->_uoSQLData['hostname'], $this->_uoSQLData['username'], $this->_uoSQLData['password']);
			
			if(is_resource($this->SQLLink)) {
				
				// Si esta especificada una base de datos, dale aqui:
				if($this->_uoSQLData['database']) {
					mysql_select_db($this->_uoSQLData['database'], $this->SQLLink);
				}
				
				
				if(function_exists("mysql_set_charset")) {
					if(isset($this->_uoSQLData['charset'])) {
						mysql_set_charset($this->_uoSQLData['charset'], $this->SQLLink);
					} else {
						mysql_set_charset("utf8", $this->SQLLink);
					}
				} else {
					
					if(isset($this->_uoSQLData['charset'])) {
						mysql_query("set names " . $this->_uoSQLData['charset'], $this->SQLLink);
					} else {
						mysql_query("SET NAMES 'utf8'", $this->SQLLink);
					}
				}

				return $this->SQLLink;
			} else {
				// Fixme, esto wtf?
				$this->_uoSQLData['tried'] = true;
				
				return $this->SQLLink = $this->setError("Error al abrir conexion con datos de conexion del SQL");
			}
		}
		
		function _uoSQLDBName() {
			return $this->_uoSQLData['database'];
		}
		
		function _uoSQLLoad() {
		}
		
		function SQLQuery($sql) {
			#uDOC:TITLE SQLQuery
			#uDOC:DESCR Eejecuta un query de SQL usando la informacion de SQL del uObject 
			
			if(! is_resource($this->_uoSQLLink())) { return $this->setError("Query de SQL sin link"); }
			if(! $this->_uoSQLDBName()) { return $this->setError("Query sin nombre de base de datos"); }
			$this->debuggerShow("uoSQL: <em>$sql</em>, ", 5);
			
			// Haz el query:
			$qvery = mysql_db_query($this->_uoSQLDBName(), $sql, $this->_uoSQLLink());
			
			// Si hay un error de SQL, mete el error de SQL al stream de errores del uobject.
			// if(! is_resource($qvery)) { $this->setError("Error de SQL: " . mysql_error($this->_uoSQLLink())); }
			
			/** Antes checabamos con is_resource() el resultado para ver si poniamos 
			/** un error. Desafortunadamente algunos tipos de queries regresan un bool
			/** como resultado (ver http://mx.php.net/mysql_db_query) y esto estaba
			/** causando que a veces el uobject pusiera error cuando no hay (BUG#738).	*/
			
			return $qvery;

		}
		
	}
	
	class uXMLRPC_Client extends uObject {
		var $URBANO_VERSION = "2.485";
		var $Server			= null;
		var $Port			= 80;
		var $Proto			= "http";
		var $Username		= null;
		var $Password		= null;
		var $URI			= "/xmlrpc/";
		var $_Post_Method	= "curl"; // curl o pphp
		protected $Encoding = "iso-8859-1";
		
		function uXMLRPC_Client($url = "") {
			if(($url) && ($partes = parse_url($url))) {
				/*
					Soporte de URLs checa aqui para RFC:
					http://mah.everybody.org/docs/xmlrpc-url-scheme-rfc
				*/
				$method = '';
				if(is_array($partes)) {
					if($partes['host']) { $this->Server = $partes['host']; }
					if($partes['host']) { $this->Server = $partes['host']; }
					if($partes['path']) {
						// Path trae el path pero tambien el metodo
						if(strpos($partes['path'], ";") !== false) {
							list($this->URI, $method) = explode(';', $partes['path']);
							// print "URI: $uri --- METHOD: $method<br />";
						} else {
							$this->URI = $partes['path'];
						}
					}
					
					// CHeca si es xmlrpc por ssl o no:
					if(($partes['scheme'] == "xmlrpcs") || ($partes['scheme'] == "https")) {
						$this->Proto = 'https';
						$this->Port = 443;
					} else {
						$this->Proto = 'http';
						$this->Port = 80;
					}
					
					// Aqui debe ir el puerto por si overridea el del protocolo:
					if(isset($partes['port'])) {
						if(is_numeric($partes['port'])) { $this->Port = $partes['port']; }
					}
					/*
					if($_SERVER['REMOTE_ADDR'] == "200.36.127.83") {
						print "<pre>"; print_r($partes); print "</pre>";
						print "<pre>"; print_r($this); print "</pre>";
						exit;
					}
					*/
					
					if((isset($partes['query'])) && ($partes['query']) && ($method)) {
						$rawargs =  explode(',',$partes['query']);
						$argumentos = Array();
						// xmlrpc_set_type ?
						foreach($rawargs as $id => $arg) {
							if(preg_match('/^string:(.+)/', $arg, $m)) {
								$argumentos[$id] = $m[1];
							} elseif(preg_match('/^int:(.+)/', $arg, $m)) {
								$argumentos[$id] = $m[1];
							} elseif(preg_match('/^boolean:(.+)/', $arg, $m)) {
								$argumentos[$id] = $m[1];
							} elseif(preg_match('/^double:(.+)/', $arg, $m)) {
								$argumentos[$id] = $m[1];
							} elseif(preg_match('/^base64:(.+)/', $arg, $m)) {
								$argumentos[$id] = $m[1];
							} elseif(preg_match('/^dateTime.iso8601:(.+)/', $arg)) {
								$argumentos[$id] = $m[1];
							}
						}
					}
					
					// Checa si el URL trae user y password
					if(isset($partes['user'])) { $this->Username	= $partes['user']; }
					if(isset($partes['pass'])) { $this->Password	= $partes['pass']; }
					
					if($method) {
						$this->LastResult = $this->Call($method, $argumentos);
					}
					
				}
			}
			return $this;
		}
		
		function Call($method, $args) {
			#uDOC:TITLE Call
			#uDOC:DESCR Haz una llamada en el server remoto
			if($this->_Post_Method == "pphp") {
				return $this->pphpPost($method, $args);
			} else {
				return $this->curlPost($method, $args);
			}
		}
		
		function _serializeRequest() {
			
		}
		
		function Proto() {
			return $this->Proto;
		}
		
		
		function Port() {
			return $this->Port;
		}
		
		function getURL() {
			#uDOC:TITLE getURL
			#uDOC:DESCR Obten el URL donde realizaremos el POST
			
			$protos = '';
			if(($this->Proto() == 'http') && ($this->Port() != 80))	{ $protos = ':' . $this->Port(); }
			if(($this->Proto() == 'https') && ($this->Port() != 443))	{ $protos = ':' . $this->Port(); }
			
			// Agrega el user y password si hay:
			if($this->Username()) {
				$auth_info = $this->Username;
				if($this->Password()) {
					$auth_info = "$auth_info:" . $this->Password();
				}
				$auth_info = "$auth_info@";
			} else { $auth_info = ""; }
			
			return $this->Proto() . '://' . $auth_info . $this->Server . $protos . $this->URI;
		}
		
		function Username() {
			#uDOC:TITLE Username
			#uDOC:DESCR Regresa el username del URL, si hay
			
			return $this->Username;
		}
		
		function Password() {
			#uDOC:TITLE Password
			#uDOC:DESCR Regresa la clave del URI
			
			return $this->Password;
			
		}
		
		function curlPost($method, $args) {
			#uDOC:TITLE curlPost
			#uDOC:DESCR Realiza el POST del paquete de XMLRPC usando el engine de CURL
			
			$this->debuggerShow("CurlPosteando $method en " . $this->Server);
			
			// Fija las opciones del output:
			$output_options = Array(
				"encoding"	=> strtolower($this->Encoding()),
			);
			
			// Encodea el request
			$request = xmlrpc_encode_request($method, $args, $output_options);
			
			$full_request = $this->_createHTTPRequest($request);
			
			$curl = curl_init($this->getURL());
			
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			
			if($this->Username()) {
				curl_setopt($curl, CURLOPT_USERPWD, $this->Username() . ":" . $this->Password());
				curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
			}
			
			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $full_request);
			
			// Esto es para que cuando va por SSL podamos tener 
			// certificados hechos en casa:
			if($this->Proto() == 'https') {
				curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
			}
			// Fija el puerto porque luego no lo pezca del URL:
			curl_setopt($curl, CURLOPT_PORT, $this->Port());
			
			$result = curl_exec($curl);
			// $this->debuggerShow("Response: " . nl2br(htmlspecialchars($result)), 2);
			
			$transfer_info = curl_getinfo($curl);
			if(($transfer_info['http_code']) && ($transfer_info['http_code'] != 200)) {
				return $this->setError("Error de HTTP:".$transfer_info['http_code']." al enviar post de XMLRPC");
			}
			
			if($result) {
				$this->debuggerShow("<span style=\"font-weight:bold;\">RESPONSE:</span><br /><pre style='margin-left: 2em; padding-left: 1em; border-left: #999 2px solid;'>".htmlspecialchars($result)."</pre>", 3);
				
				// Decodifica la respuesta en el charset mio:
				$resultado = xmlrpc_decode($result, strtolower($this->Encoding()));
				
				if((is_array($resultado)) && (isset($resultado['faultCode'])) && ($resultado['faultCode'])) {
					return $this->setError("XMLRPC Error: " . $resultado['faultString'] . "(".$resultado['faultCode'].")");
				} else {
					return $resultado;
				}
			} else {
				return $this->setError("Respuesta vacia del server de XMLRPC");
			}
			
		}
		
		function _createHTTPRequest($request) {
			#uDOC:TITLE _createHTTPRequest
			#uDOC:DESCR Crea el string de request HTTP usando el XML pasado
			
			$query  = "POST ".$this->URI." HTTP/1.0\r\n";
			
			// Agrega el header de auth si hay autentificacion:
			if($this->Username()) {
				$query .= "Authorization: Basic " . base64_encode($this->Username().":".$this->Password()) . "\r\n";
			}
			$query .= "User-Agent: uServers XMLRPC Client ".$this->URBANO_VERSION."\r\n";
			$query .= "Host: ".$this->Server."\r\n";
			$query .= "Content-Type: text/xml\r\n";
			$query .= "Content-Length: ".strlen($request)."\r\n\r\n";
			$query .= "$request\n";
			$this->debuggerShow("<span style=\"font-weight:bold;\">REQUEST:</span><br /><pre style='margin-left: 2em; padding-left: 1em; border-left: #999 2px solid;'>".htmlspecialchars($query)."</pre>", 3);
			return $query;
			
		}
		
		function pphpPost($method, $args) {
			#uDOC:TITLE pphpPost
			#uDOC:DESCR Manda un post usando puro PHP
			
			$this->debuggerShow("Llamando a " . $this->Server, 2);
			
			// Fija las opciones del output:
			$output_options = Array(
				"encoding"	=> $this->Encoding(),
			);
			
			// Encodea el request
			$request = xmlrpc_encode_request($method, $args, $output_options);
			
			$this->debuggerShow(htmlspecialchars($request), 3);
			
			$fp = fsockopen($this->Server, $this->Port, $errno, $errstr);
			
			// Aqui revisa si hay socket, si no cuelga
			if(! is_resource($fp)) { return $this->setError("Imposible abrir conexion al server de LiveChat"); }
			
			$query = $this->_createHTTPRequest($request);
			$this->debuggerShow("REQ:" . $query, 3);
			
			if (!fputs($fp, $query, strlen($query))) {
				// $errstr = "Write error";
				// return 0;
				return $this->setError("Imposible mandar post al server");
			}
			
			$contents = '';
			while (!feof($fp)) {
				$contents .= fgets($fp);
			}
			
			fclose($fp);
			
			
			if($contents) {
				$lineas = split("\n", $contents);
				foreach($lineas as $linea) {
					if(preg_match('/\<\?xml/', $linea)) { $cap++; }
					if($cap) { $xml .= $linea; }
				}
				
				if(! $xml) {
					$this->debuggerShow($contents, 3);
					return $this->setError("Imposible encontrar XML en la respuesta del server");
				}
				
				$this->debuggerShow("Response: " . nl2br(htmlspecialchars($xml)), 2);
				return xmlrpc_decode($xml);
			} else {
				return $this->setError("Imposible obtener respuesta del servidor");

			}
		}
		
		function Encoding() {
			#uDOC:TITLE Encoding
			#uDOC:DESCR Regresa el encoding que va a aplicar el cliente al request
			
			return $this->Encoding;
			
		}
		
		function setEncoding($encoding) {
			#uDOC:TITLE setEncoding
			#uDOC:DESCR Fija el encoding para el charset del request
			#uDOC:TEXTO Default es iso-8859-1 lo hice para poder usar utf-8
			
			
			// FIXME: Aqui no se si verificar
			
			$this->Encoding = $encoding;
			
			return true;
			
			
		}
		
		
	}

?>
